<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: /workplace/avs-device-sdk/CapabilityAgents/ExternalMediaPlayer/include/ExternalMediaPlayer/ExternalMediaPlayer.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_7cf910bd1d7603f12ef47ff650cec893.html">CapabilityAgents</a></li><li class="navelem"><a class="el" href="dir_a76b392fe5ef3dcdb4d5296d7cae461e.html">ExternalMediaPlayer</a></li><li class="navelem"><a class="el" href="dir_68d5dfd4dd8e84823fb789e3f3a36d40.html">include</a></li><li class="navelem"><a class="el" href="dir_a57fd16011950b030fb628b56164f104.html">ExternalMediaPlayer</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">ExternalMediaPlayer.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_external_media_player_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Copyright 2017-2018 Amazon.com, Inc. or its affiliates. All Rights Reserved.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * Licensed under the Apache License, Version 2.0 (the &quot;License&quot;).</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> * You may not use this file except in compliance with the License.</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * A copy of the License is located at</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> *     http://aws.amazon.com/apache2.0/</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * or in the &quot;license&quot; file accompanying this file. This file is distributed</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * express or implied. See the License for the specific language governing</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> * permissions and limitations under the License.</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#ifndef ALEXA_CLIENT_SDK_CAPABILITYAGENTS_EXTERNALMEDIAPLAYER_INCLUDE_EXTERNALMEDIAPLAYER_EXTERNALMEDIAPLAYER_H_</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#define ALEXA_CLIENT_SDK_CAPABILITYAGENTS_EXTERNALMEDIAPLAYER_INCLUDE_EXTERNALMEDIAPLAYER_EXTERNALMEDIAPLAYER_H_</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#include &lt;map&gt;</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#include &lt;memory&gt;</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_capability_agent_8h.html">AVSCommon/AVS/CapabilityAgent.h</a>&gt;</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_directive_handler_configuration_8h.html">AVSCommon/AVS/DirectiveHandlerConfiguration.h</a>&gt;</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_capability_configuration_interface_8h.html">AVSCommon/SDKInterfaces/CapabilityConfigurationInterface.h</a>&gt;</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_context_manager_interface_8h.html">AVSCommon/SDKInterfaces/ContextManagerInterface.h</a>&gt;</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_external_media_adapter_interface_8h.html">AVSCommon/SDKInterfaces/ExternalMediaAdapterInterface.h</a>&gt;</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_external_media_player_interface_8h.html">AVSCommon/SDKInterfaces/ExternalMediaPlayerInterface.h</a>&gt;</span></div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_external_media_player_observer_interface_8h.html">AVSCommon/SDKInterfaces/ExternalMediaPlayerObserverInterface.h</a>&gt;</span></div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_focus_manager_interface_8h.html">AVSCommon/SDKInterfaces/FocusManagerInterface.h</a>&gt;</span></div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_message_sender_interface_8h.html">AVSCommon/SDKInterfaces/MessageSenderInterface.h</a>&gt;</span></div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_playback_handler_interface_8h.html">AVSCommon/SDKInterfaces/PlaybackHandlerInterface.h</a>&gt;</span></div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_playback_router_interface_8h.html">AVSCommon/SDKInterfaces/PlaybackRouterInterface.h</a>&gt;</span></div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_speaker_manager_interface_8h.html">AVSCommon/SDKInterfaces/SpeakerManagerInterface.h</a>&gt;</span></div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_namespace_and_name_8h.html">AVSCommon/AVS/NamespaceAndName.h</a>&gt;</span></div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_media_player_interface_8h.html">AVSCommon/Utils/MediaPlayer/MediaPlayerInterface.h</a>&gt;</span></div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_requires_shutdown_8h.html">AVSCommon/Utils/RequiresShutdown.h</a>&gt;</span></div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_executor_8h.html">AVSCommon/Utils/Threading/Executor.h</a>&gt;</span></div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a> {</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="keyword">namespace </span>capabilityAgents {</div><div class="line"><a name="l00042"></a><span class="lineno"><a class="line" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1external_media_player.html">   42</a></span>&#160;<span class="keyword">namespace </span>externalMediaPlayer {</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;</div><div class="line"><a name="l00050"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html">   50</a></span>&#160;<span class="keyword">class </span><a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html">ExternalMediaPlayer</a></div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;        : <span class="keyword">public</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html">avsCommon::avs::CapabilityAgent</a></div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;        , <span class="keyword">public</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html">avsCommon::utils::RequiresShutdown</a></div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;        , <span class="keyword">public</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_capability_configuration_interface.html">avsCommon::sdkInterfaces::CapabilityConfigurationInterface</a></div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;        , <span class="keyword">public</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_external_media_player_interface.html">avsCommon::sdkInterfaces::ExternalMediaPlayerInterface</a></div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;        , <span class="keyword">public</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_playback_handler_interface.html">avsCommon::sdkInterfaces::PlaybackHandlerInterface</a></div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;        , <span class="keyword">public</span> std::enable_shared_from_this&lt;ExternalMediaPlayer&gt; {</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    <span class="comment">// Map of adapter business names to their mediaPlayers.</span></div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    <span class="keyword">using</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#a28a66411b0781be1389740d150ffe63e">AdapterMediaPlayerMap</a> =</div><div class="line"><a name="l00060"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#a28a66411b0781be1389740d150ffe63e">   60</a></span>&#160;        std::unordered_map&lt;std::string, std::shared_ptr&lt;avsCommon::utils::mediaPlayer::MediaPlayerInterface&gt;&gt;;</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    <span class="comment">// Map of adapter business names to their speakers.</span></div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    <span class="keyword">using</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#afe03eac517b773ae673e43014ee278cd">AdapterSpeakerMap</a> =</div><div class="line"><a name="l00064"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#afe03eac517b773ae673e43014ee278cd">   64</a></span>&#160;        std::unordered_map&lt;std::string, std::shared_ptr&lt;avsCommon::sdkInterfaces::SpeakerInterface&gt;&gt;;</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    <span class="comment">// Signature of functions to create an ExternalMediaAdapter.</span></div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    <span class="keyword">using</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#af7c65b4b3001c18fcd5f36da44eb7aa3">AdapterCreateFunction</a> =</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;        std::shared_ptr&lt;avsCommon::sdkInterfaces::externalMediaPlayer::ExternalMediaAdapterInterface&gt; (*)(</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;            std::shared_ptr&lt;avsCommon::utils::mediaPlayer::MediaPlayerInterface&gt; mediaPlayer,</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;            std::shared_ptr&lt;avsCommon::sdkInterfaces::SpeakerInterface&gt; speaker,</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;            std::shared_ptr&lt;avsCommon::sdkInterfaces::SpeakerManagerInterface&gt; speakerManager,</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;            std::shared_ptr&lt;avsCommon::sdkInterfaces::MessageSenderInterface&gt; messageSender,</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;            std::shared_ptr&lt;avsCommon::sdkInterfaces::FocusManagerInterface&gt; focusManager,</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;            std::shared_ptr&lt;avsCommon::sdkInterfaces::ContextManagerInterface&gt; contextManager,</div><div class="line"><a name="l00075"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#af7c65b4b3001c18fcd5f36da44eb7aa3">   75</a></span>&#160;            std::shared_ptr&lt;avsCommon::sdkInterfaces::ExternalMediaPlayerInterface&gt; externalMediaPlayer);</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    <span class="comment">// Map of adapter business names to their creation method.</span></div><div class="line"><a name="l00078"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#aaf4ebe27e2dfdda96617f1f0c2667e1c">   78</a></span>&#160;    <span class="keyword">using</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#aaf4ebe27e2dfdda96617f1f0c2667e1c">AdapterCreationMap</a> = std::unordered_map&lt;std::string, AdapterCreateFunction&gt;;</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;    <span class="keyword">static</span> std::shared_ptr&lt;ExternalMediaPlayer&gt; <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#ad2500c46956304f9eb323f009d85f957">create</a>(</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;        <span class="keyword">const</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#a28a66411b0781be1389740d150ffe63e">AdapterMediaPlayerMap</a>&amp; mediaPlayers,</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;        <span class="keyword">const</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#afe03eac517b773ae673e43014ee278cd">AdapterSpeakerMap</a>&amp; speakers,</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;        <span class="keyword">const</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#aaf4ebe27e2dfdda96617f1f0c2667e1c">AdapterCreationMap</a>&amp; adapterCreationMap,</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;        std::shared_ptr&lt;avsCommon::sdkInterfaces::SpeakerManagerInterface&gt; speakerManager,</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;        std::shared_ptr&lt;avsCommon::sdkInterfaces::MessageSenderInterface&gt; messageSender,</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;        std::shared_ptr&lt;avsCommon::sdkInterfaces::FocusManagerInterface&gt; focusManager,</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;        std::shared_ptr&lt;avsCommon::sdkInterfaces::ContextManagerInterface&gt; contextManager,</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;        std::shared_ptr&lt;avsCommon::sdkInterfaces::ExceptionEncounteredSenderInterface&gt; exceptionSender,</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;        std::shared_ptr&lt;avsCommon::sdkInterfaces::PlaybackRouterInterface&gt; playbackRouter);</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#a411c285401048584df6a15b673925b34">provideState</a>(<span class="keyword">const</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_namespace_and_name.html">avsCommon::avs::NamespaceAndName</a>&amp; stateProviderName, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> stateRequestToken)</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;        <span class="keyword">override</span>;</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#a8c183a7206e3a414f01d281463399da0">handleDirectiveImmediately</a>(std::shared_ptr&lt;avsCommon::avs::AVSDirective&gt; directive) <span class="keyword">override</span>;</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#a155ab4a13a22cef56d02f7e53310dd46">preHandleDirective</a>(std::shared_ptr&lt;DirectiveInfo&gt; info) <span class="keyword">override</span>;</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#a534f82df0aa77595bef7622ac1df5b47">handleDirective</a>(std::shared_ptr&lt;DirectiveInfo&gt; info) <span class="keyword">override</span>;</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#a072925a5404ec4192b08fc27a7fcd1a7">cancelDirective</a>(std::shared_ptr&lt;DirectiveInfo&gt; info) <span class="keyword">override</span>;</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#a00630efe454bba50a562505eb1457038">onDeregistered</a>() <span class="keyword">override</span>;</div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;    <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#a2c1f3500cf37d70ffd6c1067f9c7f921">avsCommon::avs::DirectiveHandlerConfiguration</a> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#ae6c3e74940d288662ca3c28273b1e297">getConfiguration</a>() <span class="keyword">const override</span>;</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#a5470f248f826e7b37f49289bd06e6fc6">onButtonPressed</a>(<a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#a61e425aaa1522eafa6647f6b11cb9556">avsCommon::avs::PlaybackButton</a> button) <span class="keyword">override</span>;</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#a308cb9cc7b6752ffa28a4c8541b725dc">onTogglePressed</a>(<a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#ad9f7d4000e3b111db271f73d9e34604b">avsCommon::avs::PlaybackToggle</a> toggle, <span class="keywordtype">bool</span> action) <span class="keyword">override</span>;</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#a5f5857024eae187fda8e18176f7f4e63">setPlayerInFocus</a>(<span class="keyword">const</span> std::string&amp; playerInFocus) <span class="keyword">override</span>;</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;    std::unordered_set&lt;std::shared_ptr&lt;avsCommon::avs::CapabilityConfiguration&gt;&gt; <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#a83b830e98e907125e1c211aa0e29e7f1">getCapabilityConfigurations</a>() <span class="keyword">override</span>;</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#a6d108b677d7fe0ce3cad66c908159d4d">addObserver</a>(</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;        <span class="keyword">const</span> std::shared_ptr&lt;avsCommon::sdkInterfaces::externalMediaPlayer::ExternalMediaPlayerObserverInterface&gt;</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;            observer);</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#afd79af71fe1ee4798a23bb91ba172281">removeObserver</a>(</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;        <span class="keyword">const</span> std::shared_ptr&lt;avsCommon::sdkInterfaces::externalMediaPlayer::ExternalMediaPlayerObserverInterface&gt;</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;            observer);</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html">ExternalMediaPlayer</a>(</div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;        std::shared_ptr&lt;avsCommon::sdkInterfaces::SpeakerManagerInterface&gt; speakerManager,</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;        std::shared_ptr&lt;avsCommon::sdkInterfaces::ContextManagerInterface&gt; contextManager,</div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;        std::shared_ptr&lt;avsCommon::sdkInterfaces::ExceptionEncounteredSenderInterface&gt; exceptionSender,</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;        std::shared_ptr&lt;avsCommon::sdkInterfaces::PlaybackRouterInterface&gt; playbackRouter);</div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;</div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;    std::string provideSessionState();</div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;</div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;    std::string providePlaybackState();</div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;</div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;    <span class="keywordtype">bool</span> parseDirectivePayload(std::shared_ptr&lt;DirectiveInfo&gt; info, rapidjson::Document* document);</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;</div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;    <span class="keywordtype">void</span> removeDirective(std::shared_ptr&lt;DirectiveInfo&gt; info);</div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;</div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;    <span class="keywordtype">void</span> doShutdown() <span class="keyword">override</span>;</div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;</div><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;    <span class="keywordtype">void</span> createAdapters(</div><div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;        <span class="keyword">const</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#a28a66411b0781be1389740d150ffe63e">AdapterMediaPlayerMap</a>&amp; mediaPlayers,</div><div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;        <span class="keyword">const</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#afe03eac517b773ae673e43014ee278cd">AdapterSpeakerMap</a>&amp; speakers,</div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;        <span class="keyword">const</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#aaf4ebe27e2dfdda96617f1f0c2667e1c">AdapterCreationMap</a>&amp; adapterCreationMap,</div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;        std::shared_ptr&lt;avsCommon::sdkInterfaces::MessageSenderInterface&gt; messageSender,</div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;        std::shared_ptr&lt;avsCommon::sdkInterfaces::FocusManagerInterface&gt; focusManager,</div><div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;        std::shared_ptr&lt;avsCommon::sdkInterfaces::ContextManagerInterface&gt; contextManager);</div><div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;</div><div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;    <span class="keywordtype">void</span> setHandlingCompleted(std::shared_ptr&lt;DirectiveInfo&gt; info);</div><div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;</div><div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;    <span class="keywordtype">void</span> sendExceptionEncounteredAndReportFailed(</div><div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;        std::shared_ptr&lt;DirectiveInfo&gt; info,</div><div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;        <span class="keyword">const</span> std::string&amp; message,</div><div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;        <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#ae31d62036894f4c57c46d65dee1482fc">avsCommon::avs::ExceptionErrorType</a> type = <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#ae31d62036894f4c57c46d65dee1482fcae8c0c70879b5895c615677261d64a1ee">avsCommon::avs::ExceptionErrorType::INTERNAL_ERROR</a>);</div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;</div><div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;</div><div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;    <span class="keywordtype">void</span> executeProvideState(</div><div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;        <span class="keyword">const</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_namespace_and_name.html">avsCommon::avs::NamespaceAndName</a>&amp; stateProviderName,</div><div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;        <span class="keywordtype">bool</span> sendToken = <span class="keyword">false</span>,</div><div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> stateRequestToken = 0);</div><div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;</div><div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;    std::shared_ptr&lt;avsCommon::sdkInterfaces::externalMediaPlayer::ExternalMediaAdapterInterface&gt; preprocessDirective(</div><div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;        std::shared_ptr&lt;DirectiveInfo&gt; info,</div><div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;        rapidjson::Document* document);</div><div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;</div><div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;    <span class="keywordtype">void</span> handleLogin(</div><div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;        std::shared_ptr&lt;DirectiveInfo&gt; info,</div><div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;        <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1external_media_player.html#a3ef9db230cc2a852c0dca2669733cfdd">avsCommon::sdkInterfaces::externalMediaPlayer::RequestType</a> request);</div><div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;</div><div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;    <span class="keywordtype">void</span> handleLogout(</div><div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;        std::shared_ptr&lt;DirectiveInfo&gt; info,</div><div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160;        <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1external_media_player.html#a3ef9db230cc2a852c0dca2669733cfdd">avsCommon::sdkInterfaces::externalMediaPlayer::RequestType</a> request);</div><div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;</div><div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;    <span class="keywordtype">void</span> handlePlay(</div><div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;        std::shared_ptr&lt;DirectiveInfo&gt; info,</div><div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;        <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1external_media_player.html#a3ef9db230cc2a852c0dca2669733cfdd">avsCommon::sdkInterfaces::externalMediaPlayer::RequestType</a> request);</div><div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;</div><div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;    <span class="keywordtype">void</span> handlePlayControl(</div><div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;        std::shared_ptr&lt;DirectiveInfo&gt; info,</div><div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;        <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1external_media_player.html#a3ef9db230cc2a852c0dca2669733cfdd">avsCommon::sdkInterfaces::externalMediaPlayer::RequestType</a> request);</div><div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;</div><div class="line"><a name="l00327"></a><span class="lineno">  327</span>&#160;    <span class="keywordtype">void</span> handleSeek(</div><div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160;        std::shared_ptr&lt;DirectiveInfo&gt; info,</div><div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160;        <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1external_media_player.html#a3ef9db230cc2a852c0dca2669733cfdd">avsCommon::sdkInterfaces::externalMediaPlayer::RequestType</a> request);</div><div class="line"><a name="l00330"></a><span class="lineno">  330</span>&#160;</div><div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160;    <span class="keywordtype">void</span> handleAdjustSeek(</div><div class="line"><a name="l00338"></a><span class="lineno">  338</span>&#160;        std::shared_ptr&lt;DirectiveInfo&gt; info,</div><div class="line"><a name="l00339"></a><span class="lineno">  339</span>&#160;        <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1external_media_player.html#a3ef9db230cc2a852c0dca2669733cfdd">avsCommon::sdkInterfaces::externalMediaPlayer::RequestType</a> request);</div><div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;</div><div class="line"><a name="l00347"></a><span class="lineno">  347</span>&#160;    <span class="keywordtype">void</span> notifyObservers(</div><div class="line"><a name="l00348"></a><span class="lineno">  348</span>&#160;        <span class="keyword">const</span> std::string&amp; playerId,</div><div class="line"><a name="l00349"></a><span class="lineno">  349</span>&#160;        <span class="keyword">const</span> <a class="code" href="structalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1external_media_player_1_1_observable_session_properties.html">avsCommon::sdkInterfaces::externalMediaPlayer::ObservableSessionProperties</a>* sessionProperties);</div><div class="line"><a name="l00350"></a><span class="lineno">  350</span>&#160;</div><div class="line"><a name="l00357"></a><span class="lineno">  357</span>&#160;    <span class="keywordtype">void</span> notifyObservers(</div><div class="line"><a name="l00358"></a><span class="lineno">  358</span>&#160;        <span class="keyword">const</span> std::string&amp; playerId,</div><div class="line"><a name="l00359"></a><span class="lineno">  359</span>&#160;        <span class="keyword">const</span> <a class="code" href="structalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1external_media_player_1_1_observable_playback_state_properties.html">avsCommon::sdkInterfaces::externalMediaPlayer::ObservablePlaybackStateProperties</a>* playbackProperties);</div><div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160;</div><div class="line"><a name="l00368"></a><span class="lineno">  368</span>&#160;    <span class="keywordtype">void</span> notifyObservers(</div><div class="line"><a name="l00369"></a><span class="lineno">  369</span>&#160;        <span class="keyword">const</span> std::string&amp; playerId,</div><div class="line"><a name="l00370"></a><span class="lineno">  370</span>&#160;        <span class="keyword">const</span> <a class="code" href="structalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1external_media_player_1_1_observable_session_properties.html">avsCommon::sdkInterfaces::externalMediaPlayer::ObservableSessionProperties</a>* sessionProperties,</div><div class="line"><a name="l00371"></a><span class="lineno">  371</span>&#160;        <span class="keyword">const</span> <a class="code" href="structalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1external_media_player_1_1_observable_playback_state_properties.html">avsCommon::sdkInterfaces::externalMediaPlayer::ObservablePlaybackStateProperties</a>* playbackProperties);</div><div class="line"><a name="l00372"></a><span class="lineno">  372</span>&#160;</div><div class="line"><a name="l00374"></a><span class="lineno">  374</span>&#160;    std::shared_ptr&lt;avsCommon::sdkInterfaces::SpeakerManagerInterface&gt; m_speakerManager;</div><div class="line"><a name="l00375"></a><span class="lineno">  375</span>&#160;</div><div class="line"><a name="l00377"></a><span class="lineno">  377</span>&#160;    std::shared_ptr&lt;avsCommon::sdkInterfaces::ContextManagerInterface&gt; m_contextManager;</div><div class="line"><a name="l00378"></a><span class="lineno">  378</span>&#160;</div><div class="line"><a name="l00380"></a><span class="lineno">  380</span>&#160;    std::shared_ptr&lt;avsCommon::sdkInterfaces::PlaybackRouterInterface&gt; m_playbackRouter;</div><div class="line"><a name="l00381"></a><span class="lineno">  381</span>&#160;</div><div class="line"><a name="l00383"></a><span class="lineno">  383</span>&#160;    std::map&lt;std::string, std::shared_ptr&lt;avsCommon::sdkInterfaces::externalMediaPlayer::ExternalMediaAdapterInterface&gt;&gt;</div><div class="line"><a name="l00384"></a><span class="lineno">  384</span>&#160;        m_adapters;</div><div class="line"><a name="l00385"></a><span class="lineno">  385</span>&#160;</div><div class="line"><a name="l00387"></a><span class="lineno">  387</span>&#160;    std::string m_playerInFocus;</div><div class="line"><a name="l00388"></a><span class="lineno">  388</span>&#160;</div><div class="line"><a name="l00390"></a><span class="lineno">  390</span>&#160;    std::mutex m_observersMutex;</div><div class="line"><a name="l00391"></a><span class="lineno">  391</span>&#160;</div><div class="line"><a name="l00393"></a><span class="lineno">  393</span>&#160;    std::unordered_set&lt;</div><div class="line"><a name="l00394"></a><span class="lineno">  394</span>&#160;        std::shared_ptr&lt;avsCommon::sdkInterfaces::externalMediaPlayer::ExternalMediaPlayerObserverInterface&gt;&gt;</div><div class="line"><a name="l00395"></a><span class="lineno">  395</span>&#160;        m_observers;</div><div class="line"><a name="l00396"></a><span class="lineno">  396</span>&#160;</div><div class="line"><a name="l00403"></a><span class="lineno">  403</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1threading_1_1_executor.html">avsCommon::utils::threading::Executor</a> m_executor;</div><div class="line"><a name="l00404"></a><span class="lineno">  404</span>&#160;</div><div class="line"><a name="l00406"></a><span class="lineno">  406</span>&#160;    <span class="keyword">typedef</span> void (<a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html">ExternalMediaPlayer</a>::*DirectiveHandler)(</div><div class="line"><a name="l00407"></a><span class="lineno">  407</span>&#160;        std::shared_ptr&lt;DirectiveInfo&gt; info,</div><div class="line"><a name="l00408"></a><span class="lineno">  408</span>&#160;        <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1external_media_player.html#a3ef9db230cc2a852c0dca2669733cfdd">avsCommon::sdkInterfaces::externalMediaPlayer::RequestType</a> request);</div><div class="line"><a name="l00409"></a><span class="lineno">  409</span>&#160;</div><div class="line"><a name="l00411"></a><span class="lineno">  411</span>&#160;    <span class="keyword">static</span> std::unordered_map&lt;</div><div class="line"><a name="l00412"></a><span class="lineno">  412</span>&#160;        <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_namespace_and_name.html">avsCommon::avs::NamespaceAndName</a>,</div><div class="line"><a name="l00413"></a><span class="lineno">  413</span>&#160;        std::pair&lt;avsCommon::sdkInterfaces::externalMediaPlayer::RequestType, ExternalMediaPlayer::DirectiveHandler&gt;&gt;</div><div class="line"><a name="l00414"></a><span class="lineno">  414</span>&#160;        m_directiveToHandlerMap;</div><div class="line"><a name="l00415"></a><span class="lineno">  415</span>&#160;</div><div class="line"><a name="l00417"></a><span class="lineno">  417</span>&#160;    std::unordered_set&lt;std::shared_ptr&lt;avsCommon::avs::CapabilityConfiguration&gt;&gt; m_capabilityConfigurations;</div><div class="line"><a name="l00418"></a><span class="lineno">  418</span>&#160;};</div><div class="line"><a name="l00419"></a><span class="lineno">  419</span>&#160;</div><div class="line"><a name="l00420"></a><span class="lineno">  420</span>&#160;}  <span class="comment">// namespace externalMediaPlayer</span></div><div class="line"><a name="l00421"></a><span class="lineno">  421</span>&#160;}  <span class="comment">// namespace capabilityAgents</span></div><div class="line"><a name="l00422"></a><span class="lineno">  422</span>&#160;}  <span class="comment">// namespace alexaClientSDK</span></div><div class="line"><a name="l00423"></a><span class="lineno">  423</span>&#160;</div><div class="line"><a name="l00424"></a><span class="lineno">  424</span>&#160;<span class="preprocessor">#endif  // ALEXA_CLIENT_SDK_CAPABILITYAGENTS_EXTERNALMEDIAPLAYER_INCLUDE_EXTERNALMEDIAPLAYER_EXTERNALMEDIAPLAYER_H_</span></div><div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player_html_a5f5857024eae187fda8e18176f7f4e63"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#a5f5857024eae187fda8e18176f7f4e63">alexaClientSDK::capabilityAgents::externalMediaPlayer::ExternalMediaPlayer::setPlayerInFocus</a></div><div class="ttdeci">virtual void setPlayerInFocus(const std::string &amp;playerInFocus) override</div><div class="ttdef"><b>Definition:</b> ExternalMediaPlayer.cpp:570</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player_html_a155ab4a13a22cef56d02f7e53310dd46"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#a155ab4a13a22cef56d02f7e53310dd46">alexaClientSDK::capabilityAgents::externalMediaPlayer::ExternalMediaPlayer::preHandleDirective</a></div><div class="ttdeci">void preHandleDirective(std::shared_ptr&lt; DirectiveInfo &gt; info) override</div><div class="ttdef"><b>Definition:</b> ExternalMediaPlayer.cpp:344</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html">alexaClientSDK::avsCommon::avs::CapabilityAgent</a></div><div class="ttdef"><b>Definition:</b> CapabilityAgent.h:47</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player_html_ad2500c46956304f9eb323f009d85f957"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#ad2500c46956304f9eb323f009d85f957">alexaClientSDK::capabilityAgents::externalMediaPlayer::ExternalMediaPlayer::create</a></div><div class="ttdeci">static std::shared_ptr&lt; ExternalMediaPlayer &gt; create(const AdapterMediaPlayerMap &amp;mediaPlayers, const AdapterSpeakerMap &amp;speakers, const AdapterCreationMap &amp;adapterCreationMap, std::shared_ptr&lt; avsCommon::sdkInterfaces::SpeakerManagerInterface &gt; speakerManager, std::shared_ptr&lt; avsCommon::sdkInterfaces::MessageSenderInterface &gt; messageSender, std::shared_ptr&lt; avsCommon::sdkInterfaces::FocusManagerInterface &gt; focusManager, std::shared_ptr&lt; avsCommon::sdkInterfaces::ContextManagerInterface &gt; contextManager, std::shared_ptr&lt; avsCommon::sdkInterfaces::ExceptionEncounteredSenderInterface &gt; exceptionSender, std::shared_ptr&lt; avsCommon::sdkInterfaces::PlaybackRouterInterface &gt; playbackRouter)</div><div class="ttdef"><b>Definition:</b> ExternalMediaPlayer.cpp:240</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player_html_af7c65b4b3001c18fcd5f36da44eb7aa3"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#af7c65b4b3001c18fcd5f36da44eb7aa3">alexaClientSDK::capabilityAgents::externalMediaPlayer::ExternalMediaPlayer::AdapterCreateFunction</a></div><div class="ttdeci">std::shared_ptr&lt; avsCommon::sdkInterfaces::externalMediaPlayer::ExternalMediaAdapterInterface &gt;(*)(std::shared_ptr&lt; avsCommon::utils::mediaPlayer::MediaPlayerInterface &gt; mediaPlayer, std::shared_ptr&lt; avsCommon::sdkInterfaces::SpeakerInterface &gt; speaker, std::shared_ptr&lt; avsCommon::sdkInterfaces::SpeakerManagerInterface &gt; speakerManager, std::shared_ptr&lt; avsCommon::sdkInterfaces::MessageSenderInterface &gt; messageSender, std::shared_ptr&lt; avsCommon::sdkInterfaces::FocusManagerInterface &gt; focusManager, std::shared_ptr&lt; avsCommon::sdkInterfaces::ContextManagerInterface &gt; contextManager, std::shared_ptr&lt; avsCommon::sdkInterfaces::ExternalMediaPlayerInterface &gt; externalMediaPlayer) AdapterCreateFunction</div><div class="ttdef"><b>Definition:</b> ExternalMediaPlayer.h:75</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player_html_aaf4ebe27e2dfdda96617f1f0c2667e1c"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#aaf4ebe27e2dfdda96617f1f0c2667e1c">alexaClientSDK::capabilityAgents::externalMediaPlayer::ExternalMediaPlayer::AdapterCreationMap</a></div><div class="ttdeci">std::unordered_map&lt; std::string, AdapterCreateFunction &gt; AdapterCreationMap</div><div class="ttdef"><b>Definition:</b> ExternalMediaPlayer.h:78</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player_html_afd79af71fe1ee4798a23bb91ba172281"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#afd79af71fe1ee4798a23bb91ba172281">alexaClientSDK::capabilityAgents::externalMediaPlayer::ExternalMediaPlayer::removeObserver</a></div><div class="ttdeci">void removeObserver(const std::shared_ptr&lt; avsCommon::sdkInterfaces::externalMediaPlayer::ExternalMediaPlayerObserverInterface &gt; observer)</div><div class="ttdef"><b>Definition:</b> ExternalMediaPlayer.cpp:824</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_capability_configuration_interface_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_capability_configuration_interface.html">alexaClientSDK::avsCommon::sdkInterfaces::CapabilityConfigurationInterface</a></div><div class="ttdef"><b>Definition:</b> CapabilityConfigurationInterface.h:32</div></div>
<div class="ttc" id="_external_media_player_observer_interface_8h_html"><div class="ttname"><a href="_external_media_player_observer_interface_8h.html">ExternalMediaPlayerObserverInterface.h</a></div></div>
<div class="ttc" id="_capability_agent_8h_html"><div class="ttname"><a href="_capability_agent_8h.html">CapabilityAgent.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_namespace_and_name_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_namespace_and_name.html">alexaClientSDK::avsCommon::avs::NamespaceAndName</a></div><div class="ttdef"><b>Definition:</b> NamespaceAndName.h:28</div></div>
<div class="ttc" id="_requires_shutdown_8h_html"><div class="ttname"><a href="_requires_shutdown_8h.html">RequiresShutdown.h</a></div></div>
<div class="ttc" id="_speaker_manager_interface_8h_html"><div class="ttname"><a href="_speaker_manager_interface_8h.html">SpeakerManagerInterface.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1threading_1_1_executor_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1threading_1_1_executor.html">alexaClientSDK::avsCommon::utils::threading::Executor</a></div><div class="ttdef"><b>Definition:</b> Executor.h:39</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player_html_a6d108b677d7fe0ce3cad66c908159d4d"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#a6d108b677d7fe0ce3cad66c908159d4d">alexaClientSDK::capabilityAgents::externalMediaPlayer::ExternalMediaPlayer::addObserver</a></div><div class="ttdeci">void addObserver(const std::shared_ptr&lt; avsCommon::sdkInterfaces::externalMediaPlayer::ExternalMediaPlayerObserverInterface &gt; observer)</div><div class="ttdef"><b>Definition:</b> ExternalMediaPlayer.cpp:815</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html">alexaClientSDK::avsCommon::utils::RequiresShutdown</a></div><div class="ttdef"><b>Definition:</b> RequiresShutdown.h:32</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1avs_common_1_1avs_html_ae31d62036894f4c57c46d65dee1482fc"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#ae31d62036894f4c57c46d65dee1482fc">alexaClientSDK::avsCommon::avs::ExceptionErrorType</a></div><div class="ttdeci">ExceptionErrorType</div><div class="ttdef"><b>Definition:</b> ExceptionErrorType.h:28</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player_html_a5470f248f826e7b37f49289bd06e6fc6"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#a5470f248f826e7b37f49289bd06e6fc6">alexaClientSDK::capabilityAgents::externalMediaPlayer::ExternalMediaPlayer::onButtonPressed</a></div><div class="ttdeci">virtual void onButtonPressed(avsCommon::avs::PlaybackButton button) override</div><div class="ttdef"><b>Definition:</b> ExternalMediaPlayer.cpp:576</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1external_media_player_html_a3ef9db230cc2a852c0dca2669733cfdd"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1external_media_player.html#a3ef9db230cc2a852c0dca2669733cfdd">alexaClientSDK::avsCommon::sdkInterfaces::externalMediaPlayer::RequestType</a></div><div class="ttdeci">RequestType</div><div class="ttdoc">Enum class for the different Request Types that an ExternalMediaAdapter handles. </div><div class="ttdef"><b>Definition:</b> ExternalMediaAdapterInterface.h:31</div></div>
<div class="ttc" id="_playback_router_interface_8h_html"><div class="ttname"><a href="_playback_router_interface_8h.html">PlaybackRouterInterface.h</a></div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1avs_common_1_1avs_html_a2c1f3500cf37d70ffd6c1067f9c7f921"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#a2c1f3500cf37d70ffd6c1067f9c7f921">alexaClientSDK::avsCommon::avs::DirectiveHandlerConfiguration</a></div><div class="ttdeci">std::unordered_map&lt; NamespaceAndName, BlockingPolicy &gt; DirectiveHandlerConfiguration</div><div class="ttdef"><b>Definition:</b> DirectiveHandlerConfiguration.h:32</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1avs_common_1_1avs_html_a61e425aaa1522eafa6647f6b11cb9556"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#a61e425aaa1522eafa6647f6b11cb9556">alexaClientSDK::avsCommon::avs::PlaybackButton</a></div><div class="ttdeci">PlaybackButton</div><div class="ttdoc">Enumeration class for supported playback buttons. </div><div class="ttdef"><b>Definition:</b> PlaybackButtons.h:26</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player_html_ae6c3e74940d288662ca3c28273b1e297"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#ae6c3e74940d288662ca3c28273b1e297">alexaClientSDK::capabilityAgents::externalMediaPlayer::ExternalMediaPlayer::getConfiguration</a></div><div class="ttdeci">avsCommon::avs::DirectiveHandlerConfiguration getConfiguration() const override</div><div class="ttdef"><b>Definition:</b> ExternalMediaPlayer.cpp:566</div></div>
<div class="ttc" id="_focus_manager_interface_8h_html"><div class="ttname"><a href="_focus_manager_interface_8h.html">FocusManagerInterface.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player_html_a411c285401048584df6a15b673925b34"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#a411c285401048584df6a15b673925b34">alexaClientSDK::capabilityAgents::externalMediaPlayer::ExternalMediaPlayer::provideState</a></div><div class="ttdeci">void provideState(const avsCommon::avs::NamespaceAndName &amp;stateProviderName, unsigned int stateRequestToken) override</div><div class="ttdef"><b>Definition:</b> ExternalMediaPlayer.cpp:332</div></div>
<div class="ttc" id="_external_media_player_interface_8h_html"><div class="ttname"><a href="_external_media_player_interface_8h.html">ExternalMediaPlayerInterface.h</a></div></div>
<div class="ttc" id="_media_player_interface_8h_html"><div class="ttname"><a href="_media_player_interface_8h.html">MediaPlayerInterface.h</a></div></div>
<div class="ttc" id="_executor_8h_html"><div class="ttname"><a href="_executor_8h.html">Executor.h</a></div></div>
<div class="ttc" id="_directive_handler_configuration_8h_html"><div class="ttname"><a href="_directive_handler_configuration_8h.html">DirectiveHandlerConfiguration.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html">alexaClientSDK::capabilityAgents::externalMediaPlayer::ExternalMediaPlayer</a></div><div class="ttdef"><b>Definition:</b> ExternalMediaPlayer.h:50</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player_html_a8c183a7206e3a414f01d281463399da0"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#a8c183a7206e3a414f01d281463399da0">alexaClientSDK::capabilityAgents::externalMediaPlayer::ExternalMediaPlayer::handleDirectiveImmediately</a></div><div class="ttdeci">void handleDirectiveImmediately(std::shared_ptr&lt; avsCommon::avs::AVSDirective &gt; directive) override</div><div class="ttdef"><b>Definition:</b> ExternalMediaPlayer.cpp:340</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player_html_a072925a5404ec4192b08fc27a7fcd1a7"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#a072925a5404ec4192b08fc27a7fcd1a7">alexaClientSDK::capabilityAgents::externalMediaPlayer::ExternalMediaPlayer::cancelDirective</a></div><div class="ttdeci">void cancelDirective(std::shared_ptr&lt; DirectiveInfo &gt; info) override</div><div class="ttdef"><b>Definition:</b> ExternalMediaPlayer.cpp:559</div></div>
<div class="ttc" id="_playback_handler_interface_8h_html"><div class="ttname"><a href="_playback_handler_interface_8h.html">PlaybackHandlerInterface.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player_html_a308cb9cc7b6752ffa28a4c8541b725dc"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#a308cb9cc7b6752ffa28a4c8541b725dc">alexaClientSDK::capabilityAgents::externalMediaPlayer::ExternalMediaPlayer::onTogglePressed</a></div><div class="ttdeci">virtual void onTogglePressed(avsCommon::avs::PlaybackToggle toggle, bool action) override</div><div class="ttdef"><b>Definition:</b> ExternalMediaPlayer.cpp:597</div></div>
<div class="ttc" id="_context_manager_interface_8h_html"><div class="ttname"><a href="_context_manager_interface_8h.html">ContextManagerInterface.h</a></div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1avs_common_1_1avs_html_ae31d62036894f4c57c46d65dee1482fcae8c0c70879b5895c615677261d64a1ee"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#ae31d62036894f4c57c46d65dee1482fcae8c0c70879b5895c615677261d64a1ee">alexaClientSDK::avsCommon::avs::ExceptionErrorType::INTERNAL_ERROR</a></div></div>
<div class="ttc" id="_message_sender_interface_8h_html"><div class="ttname"><a href="_message_sender_interface_8h.html">MessageSenderInterface.h</a></div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_html"><div class="ttname"><a href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></div><div class="ttdoc">Whether or not curl logs should be emitted. </div><div class="ttdef"><b>Definition:</b> AVSConnectionManager.h:37</div></div>
<div class="ttc" id="_capability_configuration_interface_8h_html"><div class="ttname"><a href="_capability_configuration_interface_8h.html">CapabilityConfigurationInterface.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player_html_a83b830e98e907125e1c211aa0e29e7f1"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#a83b830e98e907125e1c211aa0e29e7f1">alexaClientSDK::capabilityAgents::externalMediaPlayer::ExternalMediaPlayer::getCapabilityConfigurations</a></div><div class="ttdeci">std::unordered_set&lt; std::shared_ptr&lt; avsCommon::avs::CapabilityConfiguration &gt; &gt; getCapabilityConfigurations() override</div><div class="ttdef"><b>Definition:</b> ExternalMediaPlayer.cpp:811</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_external_media_player_interface_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_external_media_player_interface.html">alexaClientSDK::avsCommon::sdkInterfaces::ExternalMediaPlayerInterface</a></div><div class="ttdef"><b>Definition:</b> ExternalMediaPlayerInterface.h:35</div></div>
<div class="ttc" id="_external_media_adapter_interface_8h_html"><div class="ttname"><a href="_external_media_adapter_interface_8h.html">ExternalMediaAdapterInterface.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player_html_a28a66411b0781be1389740d150ffe63e"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#a28a66411b0781be1389740d150ffe63e">alexaClientSDK::capabilityAgents::externalMediaPlayer::ExternalMediaPlayer::AdapterMediaPlayerMap</a></div><div class="ttdeci">std::unordered_map&lt; std::string, std::shared_ptr&lt; avsCommon::utils::mediaPlayer::MediaPlayerInterface &gt; &gt; AdapterMediaPlayerMap</div><div class="ttdef"><b>Definition:</b> ExternalMediaPlayer.h:60</div></div>
<div class="ttc" id="_namespace_and_name_8h_html"><div class="ttname"><a href="_namespace_and_name_8h.html">NamespaceAndName.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player_html_a534f82df0aa77595bef7622ac1df5b47"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#a534f82df0aa77595bef7622ac1df5b47">alexaClientSDK::capabilityAgents::externalMediaPlayer::ExternalMediaPlayer::handleDirective</a></div><div class="ttdeci">void handleDirective(std::shared_ptr&lt; DirectiveInfo &gt; info) override</div><div class="ttdef"><b>Definition:</b> ExternalMediaPlayer.cpp:365</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player_html_afe03eac517b773ae673e43014ee278cd"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#afe03eac517b773ae673e43014ee278cd">alexaClientSDK::capabilityAgents::externalMediaPlayer::ExternalMediaPlayer::AdapterSpeakerMap</a></div><div class="ttdeci">std::unordered_map&lt; std::string, std::shared_ptr&lt; avsCommon::sdkInterfaces::SpeakerInterface &gt; &gt; AdapterSpeakerMap</div><div class="ttdef"><b>Definition:</b> ExternalMediaPlayer.h:64</div></div>
<div class="ttc" id="structalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1external_media_player_1_1_observable_playback_state_properties_html"><div class="ttname"><a href="structalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1external_media_player_1_1_observable_playback_state_properties.html">alexaClientSDK::avsCommon::sdkInterfaces::externalMediaPlayer::ObservablePlaybackStateProperties</a></div><div class="ttdef"><b>Definition:</b> ExternalMediaPlayerObserverInterface.h:67</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player_html_a00630efe454bba50a562505eb1457038"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#a00630efe454bba50a562505eb1457038">alexaClientSDK::capabilityAgents::externalMediaPlayer::ExternalMediaPlayer::onDeregistered</a></div><div class="ttdeci">void onDeregistered() override</div><div class="ttdef"><b>Definition:</b> ExternalMediaPlayer.cpp:563</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1avs_common_1_1avs_html_ad9f7d4000e3b111db271f73d9e34604b"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#ad9f7d4000e3b111db271f73d9e34604b">alexaClientSDK::avsCommon::avs::PlaybackToggle</a></div><div class="ttdeci">PlaybackToggle</div><div class="ttdef"><b>Definition:</b> PlaybackButtons.h:46</div></div>
<div class="ttc" id="structalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1external_media_player_1_1_observable_session_properties_html"><div class="ttname"><a href="structalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1external_media_player_1_1_observable_session_properties.html">alexaClientSDK::avsCommon::sdkInterfaces::externalMediaPlayer::ObservableSessionProperties</a></div><div class="ttdef"><b>Definition:</b> ExternalMediaPlayerObserverInterface.h:29</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_playback_handler_interface_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_playback_handler_interface.html">alexaClientSDK::avsCommon::sdkInterfaces::PlaybackHandlerInterface</a></div><div class="ttdef"><b>Definition:</b> PlaybackHandlerInterface.h:29</div></div>
</div><!-- fragment --></div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
